#
#
#
$font_name="sjis";#TFM name for TeX
$psfont="sjisrml";#TFM name for DVIware
#$rm_command="rm";#for WIN rm-->del
#
#initialize
#
$font_at=0.962216;
$half_width= ($font_at / 2);
$quater_width= ($font_at / 4);
$design_size=10;
$baseline_shift=0.045822;
#
#main part
#
open(OVP,">$font_name.ovp") || die "Can't make \'$font_name.ovp\'!\n";
binmode(OVP);
&font_header;
&write_char;
#&make_vf;
#
#definition of sub routines
#
sub font_header {
	print  OVP "(VTITLE )\n";
	print  OVP "(DESIGNSIZE R 10.000000)\n";
	print  OVP "(CHECKSUM O 0)\n";
	print  OVP "(MAPFONT D 1\n";
	print  OVP "   (FONTNAME $psfont)\n";
	print  OVP "   (FONTCHECKSUM O 0)\n";
	printf OVP "   (FONTAT R %f)\n",$font_at;
	printf OVP "   (FONTDSIZE R %f)\n",$design_size;
	print  OVP "   )\n";
}
sub write_char {
	for ($ku=1; $ku<=120; $ku++){
		for ($ten=1; $ten<=94; $ten++){
			$jiscode=($ku+32)*256+($ten+32);
			&get_shift_jiscode;
			if ($ku==1){&print_kigo_char;}elsif($ku==4){&print_kana_char;}
			elsif($ku==5){&print_kana_char;}else{&print_char;}
		}
	}
}
sub make_vf {
	close(OVP);
	system("ovp2ovf $font_name.ovp $font_name.vf $font_name.ofm");
#	system("$rm_command $font_name.ovp");
#	system("$rm_command $font_name.ofm");
}
sub print_kigo_char{
	printf OVP "(CHARACTER H %X\n", $jiscode;
	if ($jiscode>=0x2146 && $jiscode<=0x215B){#Kakko
		$width=$half_width;
	} elsif ($jiscode>=0x2122 && $jiscode<=0x2128){#Kutouten
		$width=$half_width;
	} else{
		$width=$font_at;
	}
	print  OVP "   (CHARWD R $width)\n";
	print  OVP "   (MAP\n";
	&baseline_shift;
	if (0x2126 <= $jiscode && $jiscode <= 0x2128){#colon, semicolon, nakaten
		printf OVP "      (MOVERIGHT R -%f)\n",$quater_width;}
	if (0x214A <= $jiscode && $jiscode <= 0x215B && ($jiscode%2)==0){#Kakko
		printf OVP "      (MOVERIGHT R -%f)\n",$half_width;
	}
	if (0x2146 <= $jiscode && $jiscode <=0x2149){#quatation
		printf OVP "      (MOVERIGHT R -%f)\n",$half_width;
		printf OVP "      (SETCHAR H %X)\n", $shift_jiscode;
	} else {
		printf OVP "      (SETCHAR H %X)\n",$shift_jiscode;
	}
	print  OVP "      )\n";
	print  OVP "   )\n";
}
sub print_char{
	printf OVP "(CHARACTER H %X\n", $jiscode;
	print  OVP "   (CHARWD R $font_at)\n";
	print  OVP "   (MAP\n";
	&baseline_shift;
	printf OVP "      (SETCHAR H %X)\n",$shift_jiscode;
	print  OVP "      )\n";
	print  OVP "   )\n";
}
sub print_kana_char{
	printf OVP "(CHARACTER H %X\n", $jiscode;
	print  OVP "   (CHARWD R $font_at)\n";
	print  OVP "   (MAP\n";
	&baseline_shift;
	printf OVP "      (SETCHAR H %X)\n",$shift_jiscode;
	print  OVP "      )\n";
	print  OVP "   )\n";
}
sub get_shift_jiscode{
	$c1=$ku+32;
	$c2=$ten+32;
	if ($c1 % 2) {
		$c1 = (($c1 + 1) / 2) + 0x70;
		$c2 = $c2 + 0x1f;
	} else {
		$c1 = ($c1 / 2) + 0x70;
		$c2 = $c2 + 0x7d;
	}
	if ($c1 >= 0xa0) {$c1 = $c1 + 0x40;}
	if ($c2 >= 0x7f) {$c2 = $c2 + 1;}
	$shift_jiscode=$c1*256+$c2;
}
sub baseline_shift{
	if ($baseline_shift != 0){
		printf OVP "      (MOVEDOWN R %f)\n",$baseline_shift;
	}
}
