#!/usr/bin/perl

if ($#ARGV != 0) {
	print "usage: perl ovf2jvf.pl virtualfont\n";
	exit;
}

$file = shift(@ARGV);
$file =~ s/\.ov[fp]//;
open(FILE, "<$file.ovf") || die "Can't open \'$file.ovf\'!\n";
binmode(FILE);
open(OUT, ">$file.vf") || die "$file.vf: $!";
binmode(OUT);

# Preamble
read(FILE, $_, 3);
($pre, $i, $k) = unpack('CCC', $_);
($pre == 247 && $i == 202) || die "Bad VF file!\n";
	print OUT "$_";
read(FILE, $comment, $k);
	print OUT "$comment";
read(FILE, $_, 8);
	print OUT "$_";

# Font definitions
$cmd = unpack('C', getc(FILE));
while ($cmd >= 243 && $cmd <= 246) {$reg = pack('C', $cmd); print OUT "$reg";
	read(FILE, $_, $cmd - 242);
		print OUT "$_";
	read(FILE, $_, 14);
		print OUT "$_";
	($cs, $ss, $ds, $a, $l) = unpack('NNNCC', $_);
	read(FILE, $fontname, $a + $l);
		print OUT "$fontname";
	$cmd = unpack('C', getc(FILE));
}

# Character packets
while ($cmd <= 242) {$reg = pack('C', $cmd); print OUT "$reg";
	$direction=0; $dvicode="";
	if ($cmd == 242) {	# long_char
		read(FILE, $_, 12);
		($pl, $cc, $tfm) = unpack('NNN', $_);
		read(FILE, $dvi, $pl);
		$dviorig=$dvi;
		&pret_dvi($dvi);
		if ($direction == 1){$pl=$pl-2;}
		$_=pack('NNN', $pl, $cc, $tfm);
		print OUT "$_";
		print OUT "$dvicode";
	} else {		# short_char
		$pl = $cmd;
		read(FILE, $_, 4);
			print OUT "$_";
		read(FILE, $dvi, $pl);
			print OUT "$dvi";
	}
	$cmd = unpack('C', getc(FILE));
}
#postamble
if ($cmd == 248){
	$post="";
	($size) = (stat(OUT))[7];
	if (($size%4)==0){
		$post=pack('CCCC',248,248,248,248);
	}else{
		while ($size%4){
			$post=$post.pack('C',248);
			$size++;
		}
	}
	print OUT "$post";
}else{die "Bad VF file!\n";}

sub pret_dvi {
	local ($dvi) = @_;
	local ($cmd, $k, $a, $b, $w);
	while ($dvi ne '') {
		($cmd, $dvi) = unpack('Ca*', $dvi);
		if ($cmd <= 131) {			# set_char
			if ($cmd <= 127) {
				$dvicode=$dvicode.pack('C',$cmd)
			} else {
				$k = $cmd-127;
				($_, $dvi) = unpack("a$k a*", $dvi);
				$dvicode=$dvicode.pack("Ca$k", $cmd, $_);
			}
			
		} elsif ($cmd == 132) {			# set_rule
			($a, $b, $dvi) = unpack('a4a4a*', $dvi);
			$dvicode=$dvicode.pack('Ca4a4', $cmd, $a, $b);
		} elsif ($cmd == 141) {			# push
			$dvicode=$dvicode.pack('C',$cmd)
		} elsif ($cmd == 142) {			# pop
			$dvicode=$dvicode.pack('C',$cmd)
		} elsif ($cmd >= 143 && $cmd <= 156) {	# move_right/left
			if ($cmd <= 146) {
				$k = $cmd-142;
				($_, $dvi) = unpack("a$k a*", $dvi);
				$dvicode=$dvicode.pack("Ca$k", $cmd, $_);
			} elsif ($cmd == 147) {
				$dvicode=$dvicode.pack('C',$cmd)
			} elsif ($cmd <= 151) {
				$k = $cmd-147;
				($_, $dvi) = unpack("a$k a*", $dvi);
				$dvicode=$dvicode.pack("Ca$k", $cmd, $_);
			} elsif ($cmd == 152) {
				$dvicode=$dvicode.pack('C',$cmd)
			} else {
				$k = $cmd-152;
				($_, $dvi) = unpack("a$k a*", $dvi);
				$dvicode=$dvicode.pack("Ca$k", $cmd, $_);
			}
		} elsif ($cmd >= 157 && $cmd <= 170) {	# move_up/dpwn
			if ($cmd <= 160) {
				$k = $cmd-156;
				($_, $dvi) = unpack("a$k a*", $dvi);
				$dvicode=$dvicode.pack("Ca$k", $cmd, $_);
			} elsif ($cmd == 161) {
				$dvicode=$dvicode.pack('C',$cmd)
			} elsif ($cmd <= 165) {
				$k = $cmd-161;
				($_, $dvi) = unpack("a$k a*", $dvi);
				$dvicode=$dvicode.pack("Ca$k", $cmd, $_);
			} elsif ($cmd == 166) {
				$dvicode=$dvicode.pack('C',$cmd)
			} else {
				$k = $cmd-166;
				($_, $dvi) = unpack("a$k a*", $dvi);
				$dvicode=$dvicode.pack("Ca$k", $cmd, $_);
			}
		} elsif ($cmd >= 171 && $cmd <= 238) {	# select_font
			if ($cmd <= 234) {
				$dvicode=$dvicode.pack('C',$cmd)
			} else {
				$k = $cmd-234;
				($_, $dvi) = unpack("a$k a*", $dvi);
				$dvicode=$dvicode.pack("Ca$k", $cmd, $_);
			}
		} elsif ($cmd >= 239 && $cmd <= 242) {	# xxx
			if ($cmd == 239) {	#font direction transfer
				($k, $dvi) = unpack('Ca*', $dvi);
				if ($k == 2){
					($a, $b, $dvi)=unpack('CCa*', $dvi);
					if ($a==0xFF && $b==0x00){
						$counter++;
						$direction=1;
						$dvicode=$dvicode.pack('CC',$a,$b);
					}else{
						$direction=0;
						$dvicode=$dvicode.pack('CCCC',$cmd,$k,$a,$b);
					}
				}else{
					$direction=0;
					($a, $dvi)=unpack("a$k a*", $dvi);
					$dvicode=$dvicode.pack("CCa$k",$cmd,$k,$a);
				}
			} else {
				$direction=0;
				$k = $cmd-238;
				($a, $dvi) = unpack("a$k a*", $dvi);
				$w = &get_num($a, 0);
				($b, $dvi) = unpack("a$w a*", $dvi);
				$dvicode=$dvicode.pack("Ca$k a$w",$cmd,$a,$b);
			}
		}
	}
}
